## texlive-base 2016.20160819

=== Makefile ===

all: mkii mkiv

mkii:
	texexec --passon="--shell-escape"  --once --pdf pgfplotstest
	for A in gnuplot/*.gnuplot; do gnuplot <$$A; done

mkiv:
	context --once pgfplotstest_mkiv
	for A in gnuplot/*.gnuplot; do gnuplot <$$A; done

=== texmf-dist/doc/texlive/texlive-en/Makefile ===
# $Id: Makefile 40981 2016-05-09 22:14:23Z karl $
# Makefile for TeX Live documentation.  Public domain.
doc = texlive-en

all: pdf html

env = TEXINPUTS=../texlive-common:../texlive-en:; export TEXINPUTS;

pdf:
	rm -f *.aux *.toc *.lof *.lot *.xref* *.tmp *.out
	$(env) pdflatex --file-line-error '\nonstopmode\def\Status{1}\input $(doc)'
	$(env) pdflatex '\nonstopmode\def\Status{1}\input $(doc)'
	$(env) pdflatex '\nonstopmode\def\Status{1}\input $(doc)'
	$(env) pdflatex '\nonstopmode\def\Status{1}\input $(doc)'

html:
	rm -f *.aux *.toc *.lof *.lot *.xref* *.tmp *.out *.4tc
# this sequence is equivalent to running "ht latex $(doc)".  We do it
# this way so we can \def\Status for the \ifcase in tex-live.sty.
	$(env) latex '\nonstopmode\def\Status{2}\input $(doc)'
	$(env) latex '\nonstopmode\def\Status{2}\input $(doc)'
	$(env) latex '\nonstopmode\def\Status{2}\input $(doc)'
	$(env) latex '\nonstopmode\def\Status{2}\input $(doc)'
	$(env) tex4ht $(doc)
	$(env) t4ht $(doc)

clean:
	rm -f *.aux *.log *.blg *.toc *.out *.lot tex4ht.ps *.4*
	rm -f *.xref* *.lg *.idv *.out *.otc *.tmp tmp.*
	rm -f $(doc).dvi $(doc).ps

realclean: clean
	rm -f $(doc).pdf
	rm -f *.html *.htm $(doc).css *.gif *.jpg

=== debian/changelog ===
texlive-base (2016.20160819-2) unstable; urgency=medium

  * fix package moving via unreleased tl-unicodetex (Closes: #834824)

 -- Norbert Preining <preining@debian.org>  Fri, 19 Aug 2016 23:53:03 +0900

texlive-base (2016.20160819-1) unstable; urgency=medium

  * new upstream checkout

 -- Norbert Preining <preining@debian.org>  Fri, 19 Aug 2016 12:16:58 +0900

texlive-base (2016.20160814-1) experimental; urgency=medium

  * new upstream checkout
  * adapt to takeover of tex4ht

 -- Norbert Preining <preining@debian.org>  Sun, 14 Aug 2016 22:18:00 +0900

texlive-base (2016.20160805-1) unstable; urgency=medium

  * new upstream checkout

 -- Norbert Preining <preining@debian.org>  Sat, 06 Aug 2016 09:16:53 +0900

texlive-base (2016.20160623-1) unstable; urgency=medium

  * new upstream checkout - first after the release of TL2016

 -- Norbert Preining <preining@debian.org>  Thu, 23 Jun 2016 11:15:27 +0900

texlive-base (2016.20160523-1) unstable; urgency=medium

  * new upstream checkout - TL 2016 (next trial)
    - fix lost mptopdf file syst-tex.mkii (Closes: #824835)

 -- Norbert Preining <preining@debian.org>  Mon, 23 May 2016 10:44:13 +0900

texlive-base (2016.20160520-1) unstable; urgency=medium

  * new upstream checkout - TL 2016 (first trial)
  * hyphenation files have moved to separate packages contained
    in tl-lang-*. Add replaces/breaks (Closes: #824803)

 -- Norbert Preining <preining@debian.org>  Fri, 20 May 2016 10:02:35 +0900

texlive-base (2016.20160512-1) unstable; urgency=medium

  * new upstream checkout of tlpretest
  * bump standards version, no changes necessary

 -- Norbert Preining <preining@debian.org>  Thu, 12 May 2016 10:29:59 +0900

texlive-base (2016.20160417-1) experimental; urgency=medium

  * new upstream checkout of tlpretest
  * remove stale menu file for texlive-base, replace with
    desktop file for texdoctk (Closes: #820828)
    (Thanks to Pino Toscano)

 -- Norbert Preining <preining@debian.org>  Sun, 17 Apr 2016 16:57:12 +0900

=== debian/control ===
Source: texlive-base
Section: tex
Priority: optional
Maintainer: Debian TeX Maintainers <debian-tex-maint@lists.debian.org>
Uploaders: Norbert Preining <preining@debian.org>
Build-Depends: debhelper (>= 7.0.50~)
Build-Depends-Indep: sharutils, tex-common (>= 6), findutils (>=4.2.0)
Standards-Version: 3.9.8
Homepage: http://www.tug.org/texlive/

Package: texlive-base
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ucf, tex-common (>= 6), libpaper-utils, xdg-utils, texlive-binaries (>= 2016.20160513.41080-5)
Conflicts: texlive-bibtex-extra (<< 2016), texlive-pstricks (<< 2016), texlive-formats-extra (<< 2016), texlive-omega (<< 2016), texlive-metapost (<< 2016), etoolbox (<< 2016), texlive-full (<< 2016), luasseq (<< 2015), texlive-lang-english (<< 2016), texlive-generic-recommended (<< 2016), texlive-lang-all (<< 2016), texlive-pictures-doc (<< 2016), texlive-luatex (<< 2016), texlive-extra-utils (<< 2016), texlive-pstricks-doc (<< 2016), texlive-lang-greek (<< 2016), texlive-plain-extra (<< 2016), texlive (<< 2016), texlive-metapost-doc (<< 2016), texlive-lang-portuguese (<< 2016), texlive-base (<< 2016), texlive-music (<< 2016), texlive-latex-recommended (<< 2016), texlive-font-utils (<< 2016), texlive-fonts-extra (<< 2016), luasseq (<< 2016), texlive-lang-spanish (<< 2016), texlive-latex-extra (<< 2016), texlive-games (<< 2016), texlive-lang-arabic (<< 2016), texlive-lang-other (<< 2016), texlive-humanities (<< 2016), texlive-latex-base-doc (<< 2016), texlive-lang-polish (<< 2016), texlive-lang-czechslovak (<< 2016), texlive-lang-chinese (<< 2016), texlive-binaries (<< 2016.20160513.41080-5), texlive-fonts-recommended-doc (<< 2016), texlive-lang-cyrillic (<< 2016), texlive-lang-european (<< 2016), texlive-publishers (<< 2016), texlive-htmlxml (<< 2016), texlive-lang-cjk (<< 2016), texlive-lang-french (<< 2016), texlive-lang-korean (<< 2016), texlive-generic-extra (<< 2016), texlive-humanities-doc (<< 2016), texlive-fonts-extra-doc (<< 2016), texlive-lang-italian (<< 2016), etoolbox (<< 2015), texlive-xetex (<< 2016), texlive-lang-african (<< 2016), texlive-lang-german (<< 2016), tex4ht (<< 20160814), texlive-math-extra (<< 2016), texlive-latex-recommended-doc (<< 2016), texlive-science (<< 2016), texlive-latex-base (<< 2016), texlive-lang-indic (<< 2016), texlive-science-doc (<< 2016), texlive-publishers-doc (<< 2016), texlive-lang-japanese (<< 2016), texlive-fonts-recommended (<< 2016), texlive-pictures (<< 2016), texlive-latex-extra-doc (<< 2016)
Recommends: lmodern (>= 0.93.3)
Provides: dvipdfmx
Suggests: perl-tk, gv | postscript-viewer, xpdf-reader | pdf-viewer, ghostscript
Breaks: texlive-lang-english (<< 2016), texlive-lang-greek (<< 2016), texlive-lang-portuguese (<< 2016), texlive-lang-spanish (<< 2016), texlive-lang-other (<< 2016), texlive-lang-polish (<< 2016), texlive-lang-chinese (<< 2016), texlive-lang-czechslovak (<< 2016), texlive-lang-european (<< 2016), texlive-lang-cyrillic (<< 2016), texlive-lang-french (<< 2016), texlive-lang-italian (<< 2016), texlive-lang-african (<< 2016), texlive-lang-german (<< 2016), texlive-lang-indic (<< 2016)
Description: TeX Live: Essential programs and files
 These files are regarded as basic for any TeX system, covering plain TeX 
 macros, Computer Modern fonts, and configuration for common drivers; no 
 LaTeX.
 .
 This package includes the following CTAN packages:
 .
 texlive.infra -- basic TeX Live infrastructure
 .
 amsfonts -- TeX fonts from the American Mathematical Society
 .
 bibtex -- Process bibliographies for LaTeX, etc
 .
 cm -- Computer Modern fonts
 .
 dvipdfmx -- An extended version of dvipdfm
 .
 dvips -- A DVI to PostScript driver
 .
 enctex -- A TeX extension that translates input on its way into TeX
 .
 etex -- An extended version of TeX, from the NTS project
 .
 etex-pkg -- E-TeX support package
 .
 glyphlist --
 .
 graphics-def -- Colour and graphics option files
 .
 gsftopk -- Convert "Ghostscript fonts" to PK files
 .
 hyph-utf8 -- Hyphenation patterns expressed in UTF-8
 .
 hyphen-base --
 .
 ifluatex -- Provides the \ifluatex switch
 .
 ifxetex -- Am I running under XeTeX?
 .
 knuth-lib -- A small library of Metafont sources
 .
 knuth-local -- Knuth's local information
 .
 kpathsea -- Path searching library for TeX-related files
 .
 lua-alt-getopt -- Process application arguments the same way as getopt_long
 .
 luatex -- The LuaTeX engine
 .
 makeindex -- Makeindex development sources
 .
 metafont -- A system for specifying fonts
 .
 mflogo -- LaTeX support for Metafont logo fonts
 .
 mfware -- Supporting tools for use with Metafont
 .
 pdftex -- A TeX extension for direct creation of PDF
 .
 plain -- The Plain TeX format
 .
 tetex -- scripts and files originally written for or included in teTeX
 .
 tex -- A sophisticated typesetting engine
 .
 tex-ini-files -- Model TeX format creation files
 .
 texconfig --
 .
 texlive-common -- TeX Live documentation (common elements)
 .
 texlive-docindex -- top-level TeX Live doc.html, etc.
 .
 texlive-en -- TeX Live manual (English)
 .
 unicode-data -- Unicode data and loaders for TeX
 .
 updmap-map --
 .
 xdvi -- A DVI previewer for the X Window System
 .
 texdoc -- Documentation access for TeX distributions

Package: texlive-generic-recommended
Architecture: all
Multi-Arch: foreign
Depends: texlive-base (>= 2016), texlive-base (>= 2016), ${misc:Depends}
Breaks: texlive-base (<< 2016)
Description: TeX Live: Generic recommended packages
 Recommended packages that work with multiple formats.
 .
 This package includes the following CTAN packages:
 .
 apnum -- Arbitrary precision numbers implemented by TeX macros
 .
 epsf -- Simple macros for EPS inclusion
 .
 fontname -- Scheme for naming fonts in TeX
 .
 genmisc --
 .
 kastrup -- Convert numbers into binary, octal and hexadecimal
 .
 multido -- A loop facility for Generic TeX
 .
 path -- Typeset paths, making them breakable
 .
 tex-ps -- TeX to PostScript generic macros and add-ons
 .
 ulem -- Package for underlining

Package: texlive-latex-base
Architecture: all
Multi-Arch: foreign
Depends: texlive-base (>= 2016), ${misc:Depends}, texlive-base (>= 2016), texlive-binaries (>= 2016.20160513.41080-5)
Recommends: texlive-latex-base-doc
Breaks: texlive-base (<< 2016)
Description: TeX Live: LaTeX fundamental packages
 These packages are either mandated by the core LaTeX team, or very widely 
 used and strongly recommended in practice.
 .
 This package includes the following CTAN packages:
 .
 ae -- Virtual fonts for T1 encoded CMR-fonts
 .
 amscls -- AMS document classes for LaTeX
 .
 amsmath -- AMS mathematical facilities for LaTeX
 .
 babel -- Multilingual support for Plain TeX or LaTeX
 .
 babel-english -- Babel support for English
 .
 babelbib -- Multilingual bibliographies
 .
 carlisle -- David Carlisle's small packages
 .
 colortbl -- Add colour to LaTeX tables
 .
 fancyhdr -- Extensive control of page headers and footers in LaTeX2e
 .
 fix2col -- Fix miscellaneous two column mode features
 .
 geometry -- Flexible and complete interface to document dimensions
 .
 graphics -- The LaTeX standard graphics bundle
 .
 graphics-cfg -- Sample configuration files for LaTeX color and graphics
 .
 hyperref -- Extensive support for hypertext in LaTeX
 .
 latex -- A TeX macro package that defines LaTeX
 .
 latex-bin -- LaTeX executables and man pages.
 .
 latex-fonts -- A collection of fonts used in LaTeX distributions
 .
 latexconfig --
 .
 ltxmisc -- Miscellaneous LaTeX packages, etc
 .
 mfnfss -- Packages to typeset oldgerman and pandora fonts in LaTeX
 .
 mptopdf -- mpost to PDF, native MetaPost graphics inclusion
 .
 natbib -- Flexible bibliography support
 .
 oberdiek -- A bundle of packages submitted by Heiko Oberdiek
 .
 pslatex -- Use PostScript fonts by default
 .
 psnfss -- Font support for common PostScript fonts
 .
 pspicture -- PostScript picture support
 .
 tools -- The LaTeX standard tools bundle
 .
 url -- Verbatim with URL-sensitive line breaks

Package: texlive-latex-recommended
Architecture: all
Multi-Arch: foreign
Depends: texlive-latex-base (>= 2016), ${misc:Depends}, texlive-base (>= 2016), texlive-binaries (>= 2016.20160513.41080-5)
Recommends: prosper (>= 1.00.4+cvs.2006.10.22), texlive-latex-recommended-doc
Provides: texlive-latex3, latex-xcolor, latex-beamer
Suggests: texlive-pstricks
Replaces: texlive-xetex (<< 2014.20141208),  texlive-xetex (<< 2016.20160819-1),  texlive-math-extra (<< 2016.20160819-1)
Breaks: texlive-base (<< 2016)
Description: TeX Live: LaTeX recommended packages
 A collection of recommended add-on packages for LaTeX which have widespread 
 use.
 .
 This package includes the following CTAN packages:
 .
 anysize -- A simple package to set up document margins
 .
 beamer -- A LaTeX class for producing presentations and slides
 .
 booktabs -- Publication quality tables in LaTeX
 .
 breqn -- Automatic line breaking of displayed equations
 .
 caption -- Customising captions in floating environments
 .
 cite -- Improved citation handling in LaTeX
 .
 cmap -- Make PDF files searchable and copyable
 .
 crop -- Support for cropmarks
 .
 ctable -- Flexible typesetting of table and figure floats using key/value
 directives
 .
 eso-pic -- Add picture commands (or backgrounds) to every page
 .
 euenc -- Unicode font encoding definitions for XeTeX
 .
 euler -- Use AMS Euler fonts for math
 .
 extsizes -- Extend the standard classes' size options
 .
 fancybox -- Variants of \fbox and other games with boxes
 .
 fancyref -- A LaTeX package for fancy cross-referencing
 .
 fancyvrb -- Sophisticated verbatim text
 .
 float -- Improved interface for floating objects
 .
 fontspec -- Advanced font selection in XeLaTeX and LuaLaTeX
 .
 fp -- Fixed point arithmetic
 .
 index -- Extended index for LaTeX including multiple indexes
 .
 jknapltx -- Miscellaneous packages by Joerg Knappen
 .
 koma-script -- A bundle of versatile classes and packages
 .
 l3experimental -- Experimental LaTeX3 concepts
 .
 l3kernel -- LaTeX3 programming conventions
 .
 l3packages -- High-level LaTeX3 concepts
 .
 lineno -- Line numbers on paragraphs
 .
 listings -- Typeset source code listings using LaTeX
 .
 mathspec -- Specify arbitrary fonts for mathematics in XeTeX
 .
 mathtools -- Mathematical tools to use with amsmath
 .
 mdwtools -- Miscellaneous tools by Mark Wooding
 .
 memoir -- Typeset fiction, non-fiction and mathematical books
 .
 metalogo -- Extended TeX logo macros
 .
 microtype -- Subliminal refinements towards typographical perfection
 .
 ms -- Various LaTeX packages by Martin Schroder
 .
 ntgclass -- "European" versions of standard classes
 .
 parskip -- Layout with zero \parindent, non-zero \parskip
 .
 pdfpages -- Include PDF documents in LaTeX
 .
 polyglossia -- An alternative to babel for XeLaTeX and LuaLaTeX
 .
 powerdot -- A presentation class
 .
 psfrag -- Replace strings in encapsulated PostScript figures
 .
 rcs -- Use RCS (revision control system) tags in LaTeX documents
 .
 sansmath -- Maths in a sans font
 .
 section -- Modifying section commands in LaTeX
 .
 seminar -- Make overhead slides
 .
 sepnum -- Print numbers in a "friendly" format
 .
 setspace -- Set space between lines
 .
 subfig -- Figures broken into subfigures
 .
 textcase -- Case conversion ignoring mathematics, etc
 .
 thumbpdf -- Thumbnails for pdfTeX and dvips/ps2pdf
 .
 typehtml -- Typeset HTML directly from LaTeX
 .
 underscore -- Control the behaviour of "_" in text
 .
 unicode-math -- Unicode mathematics support for XeTeX and LuaTeX
 .
 xcolor -- Driver-independent color extensions for LaTeX and pdfLaTeX
 .
 xkeyval -- Extension of the keyval package
 .
 xltxtra -- "Extras" for LaTeX users of XeTeX
 .
 xunicode -- Generate Unicode characters from accented glyphs

Package: texlive-fonts-recommended
Section: fonts
Architecture: all
Multi-Arch: foreign
Depends: texlive-base (>= 2016), texlive-base (>= 2016), ${misc:Depends}
Recommends: tex-gyre, texlive-fonts-recommended-doc, tipa (>= 2:1.2-2.1)

## texlive-base 2016.20170123

=== regressiontests/Makefile ===
# This is a regression-test framework for tex.
#
# The idea is as follows:
#
# 1. there is a reference revision on which a unittest runs as expected.
# 2. there is a way to generate the reference image (to pdf and to png)
# 3. you can compile the actual image
# 4. you can "diff" the actual image and the reference (and view the difference)
# 5. you can create a log of the single results and diffs
#
# This makefile can do all of these steps.
#
# The references can be generated with
# >> make references
# References are stored in a sub-folder called "references". You can *REMOVE* this directory
# to clean references.
#
# References are compiled using different revisions of the code; they are checked out into /tmp. 
#
#
# HOW TO WRITE TESTS
# Simply write a minimal, self-contained .tex file (say, unittest_42.tex) in this directory. It can have multiple
# pages.
# 
# If a test contains \FIXIT, it is marked as "this test is known to be broken - test issue"
#
#
# If your example needs a specific reference revision, create a file <base>.checkoutreferencerev.sh which contains something
# like "git checkout 1.3.1" . It will be invoked to checkout the reference revision.
#
# If your example needs a specific command to translate it, create a file <base>.compile.sh which runs it. Its first argument will be the base file name (without .tex).
#
# Then, type "make unittest_42.diff" to create reference, actual, and difference.
#
# Typing 'make' will make all unittests (all *.tex files in this directory).
#  
# COMPILING TESTS
# 1. compile reference, actual, and diff:
# >> make unittest_polar_7.diff
# 2. compile reference only
# >> make references/unittest_polar_7.pdf
# 3. compile actual only
# >> make unittest_polar_7.pdf
#
# The makefile will avoid re-creation of test cases in order to allow concentrate on failures.
# If you want to remake tests, you can either type 
# >> make clean
# or you can use the (standard) make feature 
# >> make unittest_polar_7.diff -B
# which forces remake, even if modtimes are unchanged 
#
#
# SPECIALTIES:
# create a file unittest_*.diff.accepted containing accepted diff results 
# (in case you approved that they are "not an error"). 
# The file should contain what the failure-output of the 'make test.diff' target.


# files with this suffix are in .gitignore
LUA_BACKEND_SUFFIX=_luabackend
AUTOMATIC_LUALATEX_BACKEND_TESTS=$(shell grep -v "\#" < luatests_automatic.list )
GENERATED_LUALATEX_BACKEND_TESTS=$(AUTOMATIC_LUALATEX_BACKEND_TESTS:%.tex=%$(LUA_BACKEND_SUFFIX).tex)

AUTOMATIC_LUALATEX_TO_PDFTEX_FALLBACK_TESTS=$(shell grep -v "\#" < luatests_automatic_texfallback.list )
GENERATED_LUALATEX_TO_PDFTEX_FALLBACK_TESTS=$(AUTOMATIC_LUALATEX_TO_PDFTEX_FALLBACK_TESTS:%.tex=%$(LUA_BACKEND_SUFFIX).tex)

UNIT_SOURCES=$(wildcard unittest_*.tex) $(GENERATED_LUALATEX_BACKEND_TESTS) $(GENERATED_LUALATEX_TO_PDFTEX_FALLBACK_TESTS)

UNIT_PDFS=$(UNIT_SOURCES:.tex=.pdf)
DIFF_MEASURES=$(UNIT_SOURCES:.tex=.diff)
DIFF_MEASURES_LUABACKEND_ONLY=$(GENERATED_LUALATEX_BACKEND_TESTS:.tex=.diff)
DIFF_MEASURES_LUABACKEND_FALLBACKS_ONLY=$(GENERATED_LUALATEX_TO_PDFTEX_FALLBACK_TESTS:.tex=.diff)

# REQUIRES apcalc package ('calc' executable)
ACCEPTED_NORMALIZED_ERROR=5e-4
DIRECTORY_FOR_ACCEPTED_ERRORS=./pgfplotsUTaccepted

INCLUDE_GRAPHICS_FROM_DIR_DIRECTORY=plotdata/risingdrop3d.png plotdata/plotgraphics3dsurf.png

# -------------------------------------------------
# stuff for references:
# allow dynamic creation of reference files. I have never used something else.
ENABLE_DYNAMIC_REFERENCES=1

STATISTICS=$$(ls unittest_*.pdf | wc -l)/$$(ls unittest_*.tex | wc -l) [F=$$(find -maxdepth 1 -name 'unittest_*.diff.png' | wc -l)]

UNIT_PDF_REFERENCES=$(UNIT_SOURCES:%.tex=references/%.pdf)
WORKING_DIR=$(shell pwd)
PGFPLOTS_GIT_BASEDIR=$(WORKING_DIR:source/latex/pgfplots/pgfplotstest/regressiontests=)
TMP_REPOSITORY=/tmp/pgfplots_copy
DEFAULT_REFERENCE_BRANCH:=$(shell git describe --tags HEAD)

# the following two variables control which PGF version is to be used for the references and the actual files, respectively:
PGF_REFERENCE_PATH=~/code/tex/pgf
#PGF_REFERENCE_PATH=~/code/tex/pgf_2.10/tex
#PGF_REFERENCE_PATH=~/code/tex/pgf_3.0.0/tex
#PGF_REFERENCE_PATH=~/code/tex/pgf_3.0.1/tex
PGF_ACTUAL_PATH=$(PGF_REFERENCE_PATH)

.PRECIOUS:  $(UNIT_SOURCES:%.tex=%.checkoutreferencerev.sh) $(UNIT_SOURCES:%.tex=%.compile.sh) $(UNIT_PDF_REFERENCES) $(UNIT_SOURCES:%.tex=%.pdf)

AUTO_INDENT_PIPE=2>&1 | sed -e 's/^/  /'
$(shell mkdir -p gnuplot references/gnuplot )
# -------------------------------------------------

.NOTPARALLEL:

# .PRECIOUS: $(UNIT_PNGS)

.PHONY: references pdf png  cleanX clean setupdirs

diff: $(DIFF_MEASURES) 

diffluaall: difflua diffluafallback

diffluafallback: $(DIFF_MEASURES_LUABACKEND_FALLBACKS_ONLY)

difflua: $(DIFF_MEASURES_LUABACKEND_ONLY)

pdf: $(UNIT_PDFS) 

clean: cleanX
	rm -fr references 

$(GENERATED_LUALATEX_BACKEND_TESTS): %$(LUA_BACKEND_SUFFIX).tex: %.tex
	@echo "Generating $@ from $^ ..."
	@rm -f $@
	@echo "\\AtBeginDocument{\\pgfplotsset{lua backend, lua debug=compileerror}}" >> $@
	@echo "% FILE HAS BEEN GENERATED because it is in luatests_automatic.list . Do NOT edit. See Makefile." >> $@
	@echo "\\input $^" >> $@

$(GENERATED_LUALATEX_TO_PDFTEX_FALLBACK_TESTS): %$(LUA_BACKEND_SUFFIX).tex: %.tex
	@echo "Generating $@ from $^ ..."
	@rm -f $@
	@echo "\\AtBeginDocument{\\pgfplotsset{lua backend, lua debug=verbose}}" >> $@
	@echo "% FILE HAS BEEN GENERATED because it is in luatests_automatic_texfallback.list . Do NOT edit. See Makefile." >> $@
	@echo "\\input $^" >> $@

# clean all except for references:
cleanX:
	rm -fr $(DIFF_MEASURES) $(UNIT_PDFS) unittest*-figure* unittest*.png $(DIRECTORY_FOR_ACCEPTED_ERRORS) $(GENERATED_LUALATEX_BACKEND_TESTS) $(GENERATED_LUALATEX_TO_PDFTEX_FALLBACK_TESTS)

%.diff.png: %.diff
	@

%.diff: %.pdf references/%.pdf
	@echo "$<: diffing --> $@ ..."
	@# touch diff.png in case the diff routine fails -- we want to see it in the error report counts
	./pdfdiff.sh $< references/$< $@ || touch $@.png
	@if [ "`cat $@`" = "0 (0)" ]; then \
		echo "  PASSED: no differences detected (removing superfluos diff-pngs)"; \
		rm -f $@.png $<.png $(DIRECTORY_FOR_ACCEPTED_ERRORS)/$@ $(DIRECTORY_FOR_ACCEPTED_ERRORS)/$@.png; # no need to keep the images (the latter for multi-page mode). \
	else \
		#echo "$<: found nonzero pixel differences `cat $@`."; \
		sed -e 's/.*(\(.*\)).*/\1/' < $@  > $@.normalized || exit 1; \
		NORMALIZED=`cat $@.normalized`; \
		rm -f $@.normalized; \
		calc -p "$$NORMALIZED < $(ACCEPTED_NORMALIZED_ERROR)" > $@.isaccepted || ( echo "calc invocation failed. Please ensure that apcalc package is installed."; exit 1 ); \
		if [ ! -f $@.accepted -a "`cat $@.isaccepted`" = "1" ]; then \
			echo "  PASSED: only approved differences `cat $@` detected and no *.accepted (less than $(ACCEPTED_NORMALIZED_ERROR); moving superfluos diff-pngs to $(DIRECTORY_FOR_ACCEPTED_ERRORS))"; \
			mkdir -p $(DIRECTORY_FOR_ACCEPTED_ERRORS); \
			mv $@.png $(DIRECTORY_FOR_ACCEPTED_ERRORS); \
			cp $@ $(DIRECTORY_FOR_ACCEPTED_ERRORS); \
			rm -f $@.png $<.png; # no need to keep the images (the latter for multi-page mode). \
		elif [ -f $@.accepted -a "`cat $@`" = "`cat $@.accepted`" ]; then \
			echo "  PASSED: only manually approved differences `cat $@` detected (moving superfluos diff-pngs to $(DIRECTORY_FOR_ACCEPTED_ERRORS))"; \
			mkdir -p $(DIRECTORY_FOR_ACCEPTED_ERRORS); \
			mv $@.png $(DIRECTORY_FOR_ACCEPTED_ERRORS); \
			cp $@ $(DIRECTORY_FOR_ACCEPTED_ERRORS); \
			rm -f $@.png $<.png; # no need to keep the images (the latter for multi-page mode). \
		else \
			echo "  FAILURE: found pixel differences for $<: " `cat $@`; \
			echo "  (if not a bug: 'echo \"`cat $@`\" > $@.accepted')"; \
			echo "  Call './displayDiff.sh $@.png' (see summarize of regressions.sh)"; \
			rm $@; # make sure it will be recomputed! \
			false; \
		fi; \
		CODE=$$?; \
		rm -f $@.isaccepted; \
		exit $$CODE; \
	fi
		


#	convert $< -append $@
#	@diff $@ references/$@; \
#	if [ ! $$? -eq 0 ]; then \
#		echo 'convert "$@" "references/$@" -compose difference -composite -colorspace gray miff:- | display' > $(@:.png=.regression.sh); \
#		echo "echo $@" >> regressions.sh; \
#		echo "sh $(@:.png=.regression.sh)" >> regressions.sh; \
#		echo "$@ WAS UNEXPECTED. See regressions.sh"; \
#		touch -t 01010000 $@; # make sure its older MMDDHHSS\
#		false;\
#	fi
	
		

references: $(UNIT_PDF_REFERENCES)

%.checkoutreferencerev.sh:
	@if [ ! -f $@ ]; then pwd; echo "generating $@ (with $(DEFAULT_REFERENCE_BRANCH))..."; echo "git checkout $(DEFAULT_REFERENCE_BRANCH)" > $@ || exit 1; fi

ifeq ($(ENABLE_DYNAMIC_REFERENCES),1)

# the automatic LUA tests simply use their pdftex result as reference
references/%$(LUA_BACKEND_SUFFIX).pdf: references/%.pdf
	@echo "$<: Using pdftex result as reference"
	ln -fs $(notdir $<) $@

references/%.pdf: %.tex %.checkoutreferencerev.sh %.compile.sh
	@echo "$<: generating $@"; \
	REFERENCE_SCRIPT=$(<:.tex=.checkoutreferencerev.sh);\
	#echo "  checking out reverence revision to $(TMP_REPOSITORY)..."; \
	if [ ! -d $(TMP_REPOSITORY) ]; then \
		cd $(dir $(TMP_REPOSITORY)) || exit 1; \
		git clone $(PGFPLOTS_GIT_BASEDIR) $(notdir $(TMP_REPOSITORY)) || exit 1; \
	fi; \
	cd $(TMP_REPOSITORY) || exit 1; \
	git reset --hard >/dev/null 2>&1; \
	cat $(WORKING_DIR)/$$REFERENCE_SCRIPT $(AUTO_INDENT_PIPE); \
	sh $(WORKING_DIR)/$$REFERENCE_SCRIPT  1>/dev/null 2>&1; \
	if [ $$? -ne 0 ]; then \
		echo "CHECKOUT FAILED." $(AUTO_INDENT_PIPE); \
		echo "(cleaning $(TMP_REPOSITORY))..." $(AUTO_INDENT_PIPE); \
		rm -fr $(TMP_REPOSITORY); \
		exit 1; \
	fi
	@#./patch_repository.sh $(TMP_REPOSITORY)
	@if [ ! -d references/plotdata ]; then cd references; ln -s ../plotdata; fi
	@cd references || exit 1;\
	export TEXINPUTS=.:..:$(TMP_REPOSITORY)/tex//:$(PGF_REFERENCE_PATH)/generic//:$(PGF_REFERENCE_PATH)/latex//:$(TEXINPUTS); \
	export LUAINPUTS="$(TMP_REPOSITORY)/tex/generic/pgfplots/lua/:$(TMP_REPOSITORY)/tex/generic/pgfplots/lua/pgfplotsoldpgfsupp:$(PGF_REFERENCE_PATH)/generic//:$(PGF_REFERENCE_PATH)/generic/pgf/libraries/luamath/:"; \
	echo "export TEXINPUTS=$${TEXINPUTS}:\$$TEXINPUTS" $(AUTO_INDENT_PIPE); \
	echo "cd references && \"compile $<\" ..." $(AUTO_INDENT_PIPE); \
	# create *.diff.png -> this makes it much more visible that it failed: \
	bash ../$(<:.tex=.compile.sh) $(<:.tex=) 1>$(<:.tex=.log.all) 2>&1 || \
		( sh ../../scripts/compile_failed.sh "../$<" "$@" "\nPlease check $(<:.tex=.checkoutreferencerev.sh)" $(AUTO_INDENT_PIPE); exit 1 )

else
#disable dynamic reference (re-)creation:
references/%.pdf: %.tex 
	@if [ ! -f $@ ]; then echo "  REFERENCE IS MISSING AND CAN'T BE CREATED AUTOMATICALLY (ENABLE_DYNAMIC_REFERENCES=0)"; exit 1; fi

endif

# make sure this rule is AFTER references/%.pdf !
%.pdf: %.tex %.compile.sh $(INCLUDE_GRAPHICS_FROM_DIR_DIRECTORY)
	@echo "$(STATISTICS) $@: recompiling $< ..."
	@rm -f $@; \
	export TEXINPUTS="./:$(PGFPLOTS_GIT_BASEDIR)/tex//:$(PGF_ACTUAL_PATH)/generic//:$(PGF_ACTUAL_PATH)/latex//:"; \
	export LUAINPUTS="$(PGFPLOTS_GIT_BASEDIR)/tex/generic/pgfplots/lua/:$(PGFPLOTS_GIT_BASEDIR)/tex/generic/pgfplots/lua/pgfplotsoldpgfsupp:$(PGF_ACTUAL_PATH)/generic//:$(PGF_ACTUAL_PATH)/generic/pgf/libraries/luamath/:"; \
	bash ./$(@:.pdf=.compile.sh) $(<:.tex=) 1>$(<:.tex=.log.all) 2>&1  || \
		( sh ../scripts/compile_failed.sh "$<" "$@" "" $(AUTO_INDENT_PIPE); exit 1 )

%$(LUA_BACKEND_SUFFIX).compile.sh:
	@if [ ! -f $@ ]; then echo "generating default $@ ..."; echo 'lualatex -shell-escape -interaction batchmode -halt-on-error "$$@"' > $@; fi

%.compile.sh:
	@if [ ! -f $@ ]; then echo "generating default $@ ..."; echo 'pdflatex -shell-escape -interaction batchmode -halt-on-error "$$@"' > $@; fi

# temporary links to graphics which are in the doc directory:
# see $(INCLUDE_GRAPHICS_FROM_DIR_DIRECTORY)
plotdata/%: 
	cd plotdata && ln -fs ../../../../../../doc/latex/pgfplots/plotdata/$(notdir $@)

=== debian/changelog ===
texlive-base (2016.20170123-5) unstable; urgency=medium

  * update LaTeX to patchlevel 3 - fixes for TU encoding

 -- Norbert Preining <preining@debian.org>  Sat, 04 Mar 2017 15:53:36 +0900

texlive-base (2016.20170123-4) unstable; urgency=medium

  * fix brown paper bag release of fontspec by including
    fontspec 2.6 (\emph was broken!) (Closes: #855491)
  * fix typo in oberdiek box drawing macros (Closes: #855390)

 -- Norbert Preining <preining@debian.org>  Mon, 20 Feb 2017 13:37:50 +0900

texlive-base (2016.20170123-3) unstable; urgency=medium

  * fix regression in LaTeX 2017/01/01 where ligatures are not
    enabled in XeLaTeX (Closes: #854930)

 -- Norbert Preining <preining@debian.org>  Sun, 12 Feb 2017 20:04:51 +0900

texlive-base (2016.20170123-2) unstable; urgency=medium

  * fix wrong replace/break statements (Closes: #852599)
  * tighten inter-package dependencies
  * add fonts-lmodern to dependency of texlive-latex-base (change since
    the introduction of TU encoding) (Closes: #853119)

 -- Norbert Preining <preining@debian.org>  Thu, 02 Feb 2017 22:14:39 +0900

texlive-base (2016.20170123-1) unstable; urgency=medium

  * new upstream checkout
    - filehook needed by unicode-math moved to tl-latex-recommended
    - several file placement errors fixed

 -- Norbert Preining <preining@debian.org>  Mon, 23 Jan 2017 10:44:49 +0900

texlive-base (2016.20170118-1) unstable; urgency=medium

  * new upstream checkout
  * renamed dep: libtcltk-ruby to ruby-tcltk (Closes: #847684)

 -- Norbert Preining <preining@debian.org>  Wed, 18 Jan 2017 08:56:22 +0900

texlive-base (2016.20161130-1) unstable; urgency=medium

  * new upstream checkout
    - remove mpost from list of commands that are allowed in 
      restricted write18 mode

 -- Norbert Preining <preining@debian.org>  Wed, 30 Nov 2016 13:18:09 +0900

texlive-base (2016.20161103-1) unstable; urgency=medium

  * new upstream checkout
    - remove non-free ehandler.ps in dvips files (Closes: #775911)
    - fix parallel mktexdir execution (Closes: #794228)

 -- Norbert Preining <preining@debian.org>  Thu, 03 Nov 2016 11:50:45 +0900

texlive-base (2016.20161008-1) unstable; urgency=medium

  * new upstream checkout
  * make texlive-full depend on biber and asymptote (Closes: #834901)
  * silence texdoctk warning about colors (Closes: #835153)
  * replace/break against texlive-common which might be left over
    from old wheezy upgrades (Closes: #836995)

 -- Norbert Preining <preining@debian.org>  Sat, 08 Oct 2016 11:07:30 +0900

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian TeX Maintainers <debian-tex-maint@lists.debian.org>
 Uploaders: Norbert Preining <preining@debian.org>
-Build-Depends: debhelper (>= 7.0.50~)
+Build-Depends: debhelper (>= 9)
 Build-Depends-Indep: sharutils, tex-common (>= 6), findutils (>=4.2.0)
 Standards-Version: 3.9.8
 Homepage: http://www.tug.org/texlive/
@@ -11,12 +11,13 @@
 Package: texlive-base
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}, ucf, tex-common (>= 6), libpaper-utils, xdg-utils, texlive-binaries (>= 2016.20160513.41080-5)
-Conflicts: texlive-bibtex-extra (<< 2016), texlive-pstricks (<< 2016), texlive-formats-extra (<< 2016), texlive-omega (<< 2016), texlive-metapost (<< 2016), etoolbox (<< 2016), texlive-full (<< 2016), luasseq (<< 2015), texlive-lang-english (<< 2016), texlive-generic-recommended (<< 2016), texlive-lang-all (<< 2016), texlive-pictures-doc (<< 2016), texlive-luatex (<< 2016), texlive-extra-utils (<< 2016), texlive-pstricks-doc (<< 2016), texlive-lang-greek (<< 2016), texlive-plain-extra (<< 2016), texlive (<< 2016), texlive-metapost-doc (<< 2016), texlive-lang-portuguese (<< 2016), texlive-base (<< 2016), texlive-music (<< 2016), texlive-latex-recommended (<< 2016), texlive-font-utils (<< 2016), texlive-fonts-extra (<< 2016), luasseq (<< 2016), texlive-lang-spanish (<< 2016), texlive-latex-extra (<< 2016), texlive-games (<< 2016), texlive-lang-arabic (<< 2016), texlive-lang-other (<< 2016), texlive-humanities (<< 2016), texlive-latex-base-doc (<< 2016), texlive-lang-polish (<< 2016), texlive-lang-czechslovak (<< 2016), texlive-lang-chinese (<< 2016), texlive-binaries (<< 2016.20160513.41080-5), texlive-fonts-recommended-doc (<< 2016), texlive-lang-cyrillic (<< 2016), texlive-lang-european (<< 2016), texlive-publishers (<< 2016), texlive-htmlxml (<< 2016), texlive-lang-cjk (<< 2016), texlive-lang-french (<< 2016), texlive-lang-korean (<< 2016), texlive-generic-extra (<< 2016), texlive-humanities-doc (<< 2016), texlive-fonts-extra-doc (<< 2016), texlive-lang-italian (<< 2016), etoolbox (<< 2015), texlive-xetex (<< 2016), texlive-lang-african (<< 2016), texlive-lang-german (<< 2016), tex4ht (<< 20160814), texlive-math-extra (<< 2016), texlive-latex-recommended-doc (<< 2016), texlive-science (<< 2016), texlive-latex-base (<< 2016), texlive-lang-indic (<< 2016), texlive-science-doc (<< 2016), texlive-publishers-doc (<< 2016), texlive-lang-japanese (<< 2016), texlive-fonts-recommended (<< 2016), texlive-pictures (<< 2016), texlive-latex-extra-doc (<< 2016)
+Depends: ${misc:Depends}, libpaper-utils, tex-common (>= 6), texlive-binaries (>= 2016.20160513.41080-7), ucf, xdg-utils
+Conflicts: etoolbox (<< 2015), etoolbox (<< 2016.20170123-2), luasseq (<< 2015), luasseq (<< 2016.20170123-2), tex4ht (<< 20160814), texlive (<< 2016.20170123-2), texlive-base (<< 2016.20170123-2), texlive-bibtex-extra (<< 2016.20170123-2), texlive-binaries (<< 2016.20160513.41080-7), texlive-extra-utils (<< 2016.20170123-2), texlive-font-utils (<< 2016.20170123-2), texlive-fonts-extra (<< 2016.20170123-2), texlive-fonts-extra-doc (<< 2016.20170123-2), texlive-fonts-recommended (<< 2016.20170123-2), texlive-fonts-recommended-doc (<< 2016.20170123-2), texlive-formats-extra (<< 2016.20170123-2), texlive-full (<< 2016.20170123-2), texlive-games (<< 2016.20170123-2), texlive-generic-extra (<< 2016.20170123-2), texlive-generic-recommended (<< 2016.20170123-2), texlive-htmlxml (<< 2016.20170123-2), texlive-humanities (<< 2016.20170123-2), texlive-humanities-doc (<< 2016.20170123-2), texlive-lang-african (<< 2016.20170123-2), texlive-lang-all (<< 2016.20170123-2), texlive-lang-arabic (<< 2016.20170123-2), texlive-lang-chinese (<< 2016.20170123-2), texlive-lang-cjk (<< 2016.20170123-2), texlive-lang-cyrillic (<< 2016.20170123-2), texlive-lang-czechslovak (<< 2016.20170123-2), texlive-lang-english (<< 2016.20170123-2), texlive-lang-european (<< 2016.20170123-2), texlive-lang-french (<< 2016.20170123-2), texlive-lang-german (<< 2016.20170123-2), texlive-lang-greek (<< 2016.20170123-2), texlive-lang-indic (<< 2016.20170123-2), texlive-lang-italian (<< 2016.20170123-2), texlive-lang-japanese (<< 2016.20170123-2), texlive-lang-korean (<< 2016.20170123-2), texlive-lang-other (<< 2016.20170123-2), texlive-lang-polish (<< 2016.20170123-2), texlive-lang-portuguese (<< 2016.20170123-2), texlive-lang-spanish (<< 2016.20170123-2), texlive-latex-base (<< 2016.20170123-2), texlive-latex-base-doc (<< 2016.20170123-2), texlive-latex-extra (<< 2016.20170123-2), texlive-latex-extra-doc (<< 2016.20170123-2), texlive-latex-recommended (<< 2016.20170123-2), texlive-latex-recommended-doc (<< 2016.20170123-2), texlive-luatex (<< 2016.20170123-2), texlive-metapost (<< 2016.20170123-2), texlive-metapost-doc (<< 2016.20170123-2), texlive-music (<< 2016.20170123-2), texlive-omega (<< 2016.20170123-2), texlive-pictures (<< 2016.20170123-2), texlive-pictures-doc (<< 2016.20170123-2), texlive-plain-extra (<< 2016.20170123-2), texlive-pstricks (<< 2016.20170123-2), texlive-pstricks-doc (<< 2016.20170123-2), texlive-publishers (<< 2016.20170123-2), texlive-publishers-doc (<< 2016.20170123-2), texlive-science (<< 2016.20170123-2), texlive-science-doc (<< 2016.20170123-2), texlive-xetex (<< 2016.20170123-2)
 Recommends: lmodern (>= 0.93.3)
 Provides: dvipdfmx
-Suggests: perl-tk, gv | postscript-viewer, xpdf-reader | pdf-viewer, ghostscript
-Breaks: texlive-lang-english (<< 2016), texlive-lang-greek (<< 2016), texlive-lang-portuguese (<< 2016), texlive-lang-spanish (<< 2016), texlive-lang-other (<< 2016), texlive-lang-polish (<< 2016), texlive-lang-chinese (<< 2016), texlive-lang-czechslovak (<< 2016), texlive-lang-european (<< 2016), texlive-lang-cyrillic (<< 2016), texlive-lang-french (<< 2016), texlive-lang-italian (<< 2016), texlive-lang-african (<< 2016), texlive-lang-german (<< 2016), texlive-lang-indic (<< 2016)
+Suggests: ghostscript, gv | postscript-viewer, perl-tk, xpdf-reader | pdf-viewer
+Replaces: texlive-common (<< 2013)
+Breaks: texlive-common (<< 2013)
 Description: TeX Live: Essential programs and files
  These files are regarded as basic for any TeX system, covering plain TeX 
  macros, Computer Modern fonts, and configuration for common drivers; no 
@@ -103,8 +104,8 @@
 Package: texlive-generic-recommended
 Architecture: all
 Multi-Arch: foreign
-Depends: texlive-base (>= 2016), texlive-base (>= 2016), ${misc:Depends}
-Breaks: texlive-base (<< 2016)
+Depends: ${misc:Depends}, texlive-base (>= 2016.20170123-2), texlive-base (>= 2016.20170123-2)
+Breaks: texlive-base (<< 2016.20170123-2)
 Description: TeX Live: Generic recommended packages
  Recommended packages that work with multiple formats.
  .
@@ -131,9 +132,9 @@
 Package: texlive-latex-base
 Architecture: all
 Multi-Arch: foreign
-Depends: texlive-base (>= 2016), ${misc:Depends}, texlive-base (>= 2016), texlive-binaries (>= 2016.20160513.41080-5)
+Depends: ${misc:Depends}, fonts-lmodern, texlive-base (>= 2016.20170123-2), texlive-base (>= 2016.20170123-2), texlive-binaries (>= 2016.20160513.41080-7)
 Recommends: texlive-latex-base-doc
-Breaks: texlive-base (<< 2016)
+Breaks: texlive-base (<< 2016.20170123-2)
 Description: TeX Live: LaTeX fundamental packages
  These packages are either mandated by the core LaTeX team, or very widely 
  used and strongly recommended in practice.
@@ -199,12 +200,12 @@
 Package: texlive-latex-recommended
 Architecture: all
 Multi-Arch: foreign
-Depends: texlive-latex-base (>= 2016), ${misc:Depends}, texlive-base (>= 2016), texlive-binaries (>= 2016.20160513.41080-5)
+Depends: ${misc:Depends}, texlive-base (>= 2016.20170123-2), texlive-binaries (>= 2016.20160513.41080-7), texlive-latex-base (>= 2016.20170123-2)
 Recommends: prosper (>= 1.00.4+cvs.2006.10.22), texlive-latex-recommended-doc
-Provides: texlive-latex3, latex-xcolor, latex-beamer
+Provides: latex-beamer, latex-xcolor, texlive-latex3
 Suggests: texlive-pstricks
-Replaces: texlive-xetex (<< 2014.20141208),  texlive-xetex (<< 2016.20160819-1),  texlive-math-extra (<< 2016.20160819-1)
-Breaks: texlive-base (<< 2016)
+Replaces:  texlive-math-extra (<< 2016.20160819-1),  texlive-xetex (<< 2016.20160819-1), texlive-latex-extra (<< 2016.20170123), texlive-xetex (<< 2014.20141208)
+Breaks:  texlive-math-extra (<< 2016.20160819-1),  texlive-xetex (<< 2016.20160819-1), texlive-base (<< 2016.20170123-2), texlive-latex-extra (<< 2016.20170123), texlive-xetex (<< 2014.20141208)
 Description: TeX Live: LaTeX recommended packages
  A collection of recommended add-on packages for LaTeX which have widespread 
  use.
@@ -244,6 +245,8 @@
  .
  fancyvrb -- Sophisticated verbatim text
  .
+ filehook -- Hooks for input files
+ .
  float -- Improved interface for floating objects
  .
  fontspec -- Advanced font selection in XeLaTeX and LuaLaTeX
@@ -313,20 +316,3 @@
  typehtml -- Typeset HTML directly from LaTeX
  .
  underscore -- Control the behaviour of "_" in text
- .
- unicode-math -- Unicode mathematics support for XeTeX and LuaTeX
- .
- xcolor -- Driver-independent color extensions for LaTeX and pdfLaTeX
- .
- xkeyval -- Extension of the keyval package
- .
- xltxtra -- "Extras" for LaTeX users of XeTeX
- .
- xunicode -- Generate Unicode characters from accented glyphs
-
-Package: texlive-fonts-recommended
-Section: fonts
-Architecture: all
-Multi-Arch: foreign
-Depends: texlive-base (>= 2016), texlive-base (>= 2016), ${misc:Depends}
-Recommends: tex-gyre, texlive-fonts-recommended-doc, tipa (>= 2:1.2-2.1)

=== debian/rules ===
#!/usr/bin/make -f
# 
# debian/rules file for texlive-base

PACKAGES=texlive-base texlive-generic-recommended texlive-latex-base texlive-latex-recommended texlive-fonts-recommended texlive-pictures texlive-luatex texlive-metapost texlive-omega texlive-xetex texlive-fonts-recommended-doc texlive-latex-base-doc texlive-latex-recommended-doc texlive-metapost-doc texlive-pictures-doc
METAPACKAGES=luasseq texlive texlive-full

SHELL=/bin/bash

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp:
	touch build-stamp

clean: 
	for i in $(PACKAGES) $(METAPACKAGES) ; do \
	  rm -f debian/$$i.{README.Debian,links,links.generated} ; \
	  rm -f debian/$$i.{postinst,postrm,preinst,prerm} ; \
	  rm -f debian/$$i.{maps,hyphens,formats,info,manpages} ; \
	  rm -f debian/$$i.{lintian-overrides} ; \
	done

	rm -f debian/texlive-base.cnf

	# texlive contains some .orig files we need to keep otherwise
	# the copy will fail due to the files occurring in the tlpdb
	dh_clean -X.orig -X.bak
	rm -f configure-stamp
	rm -f build-stamp
	rm -f install-stamp

install: install-stamp

install-stamp: build-stamp
	# make sure we have texmf-dist/web2c otherwise the media detection
	# might break (like in texlive-lang)
	mkdir -p texmf-dist/web2c
	perl debian/tpm2deb-bin.pl --nosource $(PACKAGES) $(METAPACKAGES)
	for i in $(PACKAGES) $(METAPACKAGES) ; do \
	  bash debian/generate-license-file $$i ; \
	  bash debian/fix-privacy-breach $$i ; \
	  find debian/$i/usr/share -name \*.jar -exec chmod ugo-x '{}' \; ; \
	  if [ -r debian/$$i.links.dist ] ; then cat debian/$$i.links.dist >> debian/$$i.links ; fi ; \
	done

	mkdir -p debian/texlive-base/etc/texmf/texdoctk
	mv debian/texlive-base/usr/share/texlive/texmf-dist/texdoctk/texdocrc.defaults \
	  debian/texlive-base/etc/texmf/texdoctk
	rmdir --ignore-fail-on-non-empty debian/texlive-base/usr/share/texlive/texmf-dist/texdoctk
	mkdir -p debian/texlive-base/usr/share/applications
	install debian/texdoctk.desktop debian/texlive-base/usr/share/applications

	# move ltx-help.el into emacs directory

	for i in $(PACKAGES) $(METAPACKAGES) ; do \
	  bash debian/create-font-links $$i >> debian/$$i.links ; \
	done
	touch install-stamp

binary-arch:

binary-indep: build install
	dh_testdir
	dh_testroot
	dh_install
	dh_installdirs
	#dh_installmenu
	dh_lintian
	dh_bugfiles -A
	dh_installdocs -A debian/README.source debian/README.Debian

	dh_installdocs -p texlive-base README readme-txt.dir readme-html.dir debian/CHANGES.packaging
	# nasty trick
	# mptopdf needs a dump, but is a link to a script
	# we have to trick dh_installtex to accept it
	mv debian/texlive-latex-base/usr/bin/mptopdf	\
		debian/texlive-latex-base/usr/bin/mptopdf.bck
	ln -s pdftex debian/texlive-latex-base/usr/bin/mptopdf
	dh_installtex -Ntexlive-base -A 		\
		$(patsubst %,-N%,$(METAPACKAGES))	\
		--flavor=tree:texlive
	# nasty trick undoing
	rm debian/texlive-latex-base/usr/bin/mptopdf
	mv debian/texlive-latex-base/usr/bin/mptopdf.bck	\
		debian/texlive-latex-base/usr/bin/mptopdf
	# end of nasty trick
	dh_installtex -ptexlive-base --flavor=tree:texlive
	# /usr/bin/mf has been created by dh_installtex as symlink to 
	# mf-nowin, but is also shipped by texlive-binaries, remove it.
	rm debian/texlive-base/usr/bin/mf
	# furthermore we want to have etex and pdfetex as links in 
	# texlive-binaries and not in texlive-base, remove them here
	# and add them via dh_link in texlive-binaries
	# this is just out of history, would be nicer to have changed
	rm debian/texlive-base/usr/bin/etex 
	rm debian/texlive-base/usr/bin/pdfetex
	# for the libpaper hook, install templates and
	# translations. No need to modify postrm. I hope it accepts
	# the missing config script
	dh_installdebconf -n
	cp debian/texlive-base.libpaper debian/texlive-base/etc/libpaper.d/texlive-base
	chmod a+x debian/texlive-base/etc/libpaper.d/texlive-base

	dh_installemacsen
	dh_installchangelogs
	dh_installman
	bash debian/fix-manpages.sh
	# info pages
	bash debian/convert-info-files-to-unix.sh
	dh_installinfo

	# remove info files that are present in texlive-binaries
	# has to be done after the dh_installinfo call
	rm debian/texlive-base/usr/share/info/dvips.info*
	rm debian/texlive-base/usr/share/info/web2c.info*
	rm debian/texlive-base/usr/share/info/kpathsea.info*
	rmdir --ignore-fail-on-non-empty debian/texlive-base/usr/share/info

	dh_installmime
	dh_lintian
	dh_link
	dh_compress -X.pdf
	dh_fixperms
	# remove .bat files, nobody needs them
	find debian/texlive-*/usr/share/texlive/texmf-dist/ -name \*.bat -a -type f -exec rm '{}' \;
	# remove x bit from files in the doc hierarchy
	find debian/texlive-*/usr/share/doc/texlive-doc -type f -exec chmod a-x '{}' \;
	# remove x bit from jar files
	find debian/texlive-*/usr/share/texlive -name \*.jar -exec chmod a-x '{}' \;
	# we also have to fix the permissions of the link targets from /usr/bin
	bash debian/fix-bin-symlink-targets-permissions.sh
	dh_installdeb
	dh_gencontrol
	dh_md5sums

	dh_builddeb -- -Zxz


binary: binary-indep binary-arch

.PHONY: build clean binary-indep binary-arch binary install

# eof
